Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/material.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/material.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/material.cc	(revision 4139)
@@ -45,12 +45,7 @@
   this->setTransparency(1.0);
 
-
   this->diffuseTexture = NULL;
   this->ambientTexture = NULL;
   this->specularTexture = NULL;
-
-  this->diffuseTextureSet = false;
-  this->ambientTextureSet = false;
-  this->specularTextureSet = false;
 
   this->setName(mtlName);
@@ -107,5 +102,5 @@
     glShadeModel(GL_SMOOTH);
 
-  if (this->diffuseTextureSet)
+  if (this->diffuseTexture)
     {
       glEnable(GL_TEXTURE_2D);
@@ -300,10 +295,8 @@
 {
   PRINTF(4)("setting Diffuse Map %s\n", dMap);
-  //    diffuseTexture = new Texture();
-  //    this->diffuseTextureSet = diffuseTexture->loadImage(dMap);
 
   //! \todo check if RESOURCE MANAGER is availiable
   //! \todo Textures from .mtl-file need special care.
-  this->diffuseTextureSet = this->diffuseTexture = (Texture*)ResourceManager::getInstance()->load(dMap, IMAGE);
+  this->diffuseTexture = (Texture*)ResourceManager::getInstance()->load(dMap, IMAGE);
 }
 
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/material.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/material.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/material.h	(revision 4139)
@@ -67,9 +67,4 @@
   Texture* ambientTexture; //!< The ambient texture of the Material.
   Texture* specularTexture;//!< The specular texture of the Material.
-  
-  bool diffuseTextureSet; //!< Chekcs if the diffuse texture is Set.
-  bool ambientTextureSet; //!< Chekcs if the ambient texture is Set.
-  bool specularTextureSet;//!< Chekcs if the specular texture is Set.
-
 };
 #endif
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/model.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/model.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/model.cc	(revision 4139)
@@ -36,4 +36,8 @@
 ModelFaceElement::ModelFaceElement()
 {
+  this->vertexNumber = -1;
+  this->normalNumber = -1;
+  this->texCoordNumber = -1;    
+
   this->next = NULL;
 }
@@ -140,4 +144,7 @@
   this->currentGroup = this->firstGroup = new ModelGroup;
   this->groupCount = 0;
+  this->vertexCount = 0;
+  this->normalCount = 0;
+  this->texCoordCount = 0;
   
   this->scaleFactor = 1;
@@ -355,5 +362,4 @@
 Material* Model::addMaterial(const char* materialName)
 {
-  
   Material* newMat = new Material();
   newMat->setName(materialName);
@@ -424,4 +430,5 @@
   PRINTF(5)("reading in a vertex: %f %f %f\n", &subbuffer1, &subbuffer2, &subbuffer3);
   this->vertices->addEntry(subbuffer1*scaleFactor, subbuffer2*scaleFactor, subbuffer3*scaleFactor);
+  this->vertexCount++;
   return true;
 }
@@ -438,4 +445,5 @@
   PRINTF(5)("reading in a vertex: %f %f %f\n", x, y, z);
   this->vertices->addEntry(x*scaleFactor, y*scaleFactor, z*scaleFactor);
+  this->vertexCount++;
   return true;
 }
@@ -455,4 +463,5 @@
   PRINTF(5)("found vertex-Normal %f, %f, %f\n", &subbuffer1,&subbuffer2,&subbuffer3);
   this->normals->addEntry(subbuffer1, subbuffer2, subbuffer3);
+  this->normalCount++;
   return true;
 }
@@ -470,4 +479,6 @@
   PRINTF(5)("found vertex-Normal %f, %f, %f\n", x, y, z);
   this->normals->addEntry(x, y, z);
+  this->normalCount++;
+  return true;
 }
 
@@ -487,4 +498,5 @@
   this->vTexture->addEntry(subbuffer1);
   this->vTexture->addEntry(subbuffer2);
+  this->texCoordCount++;
   return true;
 }
@@ -502,4 +514,6 @@
   this->vTexture->addEntry(u);
   this->vTexture->addEntry(v);
+  this->texCoordCount++;
+  return true;
 }
 
@@ -509,4 +523,6 @@
 
    If a face line is found this function will add it to the glList.
+
+   String is different from the argument addFace, in this that the first Vertex/Normal/Texcoord is 1 instead of 0
 */
 bool Model::addFace (const char* faceString)
@@ -546,14 +562,8 @@
       if (vertex)
 	tmpElem->vertexNumber = atoi(vertex)-1;
-      else
-	tmpElem->vertexNumber = -1;
       if (texture)
 	tmpElem->texCoordNumber = atoi(texture)-1;
-      else
-	tmpElem->texCoordNumber = -1;
       if (normal)
 	tmpElem->normalNumber = atoi(normal)-1;
-      else
-	tmpElem->normalNumber = -1;
 
       faceString += tmpLen;
@@ -569,5 +579,5 @@
    \brief adds a new Face
    \param faceElemCount the number of Vertices to add to the Face.
-   \param type 0: vertex only, 1: vertex and normal, 2: vertex and Texture, 3 vertex, normal and texture
+   \param type The information Passed with each Vertex
 */
 bool Model::addFace(int faceElemCount, VERTEX_FORMAT type, ...)
@@ -583,12 +593,12 @@
   for (int i = 0; i < faceElemCount; i++)
     {
-      if (this->currentGroup->currentFace->vertexCount>0)
+      if (this->currentGroup->currentFace->vertexCount > 0)
 	tmpElem = tmpElem->next = new ModelFaceElement;
 
-      tmpElem->vertexNumber = va_arg (itemlist, int) -1;
+      tmpElem->vertexNumber = va_arg (itemlist, int);
       if (type & TEXCOORD)
-	tmpElem->texCoordNumber = va_arg (itemlist, int) -1;
+	tmpElem->texCoordNumber = va_arg (itemlist, int);
       if (type & NORMAL)
- 	tmpElem->normalNumber = va_arg(itemlist, int) -1;
+ 	tmpElem->normalNumber = va_arg(itemlist, int);
       this->currentGroup->currentFace->vertexCount++;
     }
@@ -693,10 +703,10 @@
     }
 
-  for (int i=0; i<vertices->getCount()/3;i++)
+  for (int i=0; i < vertices->getCount()/3;i++)
     {
       normArray[i].normalize();
       PRINTF(5)("Found Normale number %d: (%f; %f, %f).\n", i, normArray[i].x, normArray[i].y, normArray[i].z);
       
-      this->normals->addEntry(normArray[i].x, normArray[i].y, normArray[i].z);
+      this->addVertexNormal(normArray[i].x, normArray[i].y, normArray[i].z);
 
     }
@@ -834,9 +844,28 @@
 
   if (elem->texCoordNumber != -1)
-    glTexCoord2fv(this->vTexture->getArray() + elem->texCoordNumber * 2);
+    {
+      if (likely(elem->texCoordNumber < this->texCoordCount))
+	glTexCoord2fv(this->vTexture->getArray() + elem->texCoordNumber * 2);
+      else
+	PRINTF(2)("TextureCoordinate %d is not in the List (max: %d)\nThe Model might be incomplete\n",
+		  elem->texCoordNumber, this->texCoordCount);
+    }
   if (elem->normalNumber != -1)
-    glNormal3fv(this->normals->getArray() + elem->normalNumber * 3);
+    {
+    if (likely(elem->normalNumber < this->normalCount))
+      glNormal3fv(this->normals->getArray() + elem->normalNumber * 3);
+    else
+	PRINTF(2)("Normal %d is not in the List (max: %d)\nThe Model might be incomplete",
+		  elem->normalNumber, this->normalCount);      
+    }
   if (elem->vertexNumber != -1)
-    glVertex3fv(this->vertices->getArray() + elem->vertexNumber * 3);
+    {
+      if (likely(elem->vertexNumber < this->vertexCount))
+	  glVertex3fv(this->vertices->getArray() + elem->vertexNumber * 3);
+      else
+	PRINTF(2)("Vertex %d is not in the List (max: %d)\nThe Model might be incomplete",
+		  elem->vertexNumber, this->vertexCount);      
+    }	
+
 }
 
@@ -897,19 +926,10 @@
   this->addVertexNormal (-1.0, 0.0, 0.0);
 
-  /* normaleLess-testingMode
-  this->addFace ("1 2 4 3");
-  this->addFace ("3 4 6 5");
-  this->addFace ("5 6 8 7");
-  this->addFace ("7 8 2 1");
-  this->addFace ("2 8 6 4");
-  this->addFace ("7 1 3 5");
-  */
-
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,1,1, 2,2,2, 4,4,3, 3,3,4);
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 3,3,5, 4,4,6, 6,6,7, 5,5,8);
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 5,5,9, 6,6,10, 8,8,11, 7,7,12);
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,7,13, 8,8,14, 2,10,15, 1,9,16);
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,2,17, 8,11,18, 6,12,19, 4,4,20);
-  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,13,21, 1,1,22, 3,3,23, 5,14,24);
-
-}
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 0,0,0, 1,1,1, 3,3,2, 2,2,3);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,2,4, 3,3,5, 5,5,6, 4,4,7);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 4,4,8, 5,5,9, 7,7,10, 6,6,11);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 6,6,12, 7,7,13, 1,9,14, 0,8,15);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,1,16, 7,10,17, 5,11,18, 3,3,19);
+  this->addFace (4, VERTEX_TEXCOORD_NORMAL, 6,12,20, 0,0,21, 2,2,22, 4,13,23);
+
+}
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/model.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/model.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/model.h	(revision 4139)
@@ -100,6 +100,8 @@
   bool finalized;             //!< Sets the Object to be finalized.
 
+  int vertexCount;            //!< A modelwide Counter for vertices.
+  int normalCount;            //!< A modelwide Counter for the normals.
+  int texCoordCount;          //!< A modelwide Counter for the texCoord.
   Array* vertices;            //!< The Array that handles the Vertices.
-  int verticesCount;          //!< A global Counter for vertices.
   Array* normals;             //!< The Array that handles the Normals.
   Array* vTexture;            //!< The Array that handles the VertexTextureCoordinates.
@@ -159,4 +161,11 @@
   bool setMaterial(Material* mtl);
   void finalize(void);
+
+  /** \returns The number of Vertices of the Model */
+  inline int getVertexCount(void) const {return this->vertexCount;}
+  /** \returns The number of Normals of the Model */
+  inline int getNormalCount(void) const {return this->normalCount;}
+  /** \returns The number of Texture Coordinates of the Model*/
+  inline int getTexCoordCount(void) const {return this->texCoordCount;}
 };
 
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.cc	(revision 4139)
@@ -34,5 +34,6 @@
 OBJModel::OBJModel(const char* fileName, float scaling) : Model(fileName)
 {
-  this->initializeOBJ();
+  this->objPath = "./";
+
   this->scaleFactor = scaling;
 
@@ -52,18 +53,4 @@
   if (this->objPath)
     delete []this->objPath;
-  if (this->objFileName)
-    delete []this->objFileName;
-  if (this->mtlFileName)
-    delete []this->mtlFileName;
-}
-
-/**
-   \brief Initializes an obj-model
-*/
-void OBJModel::initializeOBJ(void)
-{
-  this->objPath = NULL;
-  this->objFileName = NULL;
-  this->mtlFileName = NULL;
 }
 
@@ -71,39 +58,24 @@
    \brief Imports a obj file and handles the the relative location
    \param fileName The file to import
+
+   Splits the FileName from the DirectoryName
 */
 bool OBJModel::importFile (const char* fileName)
 {
   PRINTF(4)("preparing to read in file: %s\n", fileName);
-
-
-#ifdef __WIN32__
-  // win32 path reading
-  char pathSplitter= '\\';
-#else /* __WIN32__ */
-  // unix path reading
-  char pathSplitter='/';
-#endif /* __WIN32__ */
-  char* tmpName;
-  strcpy(tmpName, fileName);
-  if (tmpName[0] == pathSplitter)
-    tmpName++;
-  char* name = tmpName;
-  while (( tmpName = strchr (tmpName+1, pathSplitter)))
-    {
-      name = tmpName+1;
-    }
-  this->objPath = new char[name-fileName+1];
-  strncpy(this->objPath, fileName, name-fileName);
-  this->objPath[name-fileName] = '\0';
-  if (strlen(objPath)> 0)
-    PRINTF(5)("Resolved file %s to folder: %s.\n", name, objPath);
-  else
-    PRINTF(5)("Resolved file %s.\n", name);
-  
-  this->setName(name);
-
-  this->objFileName = new char[strlen(name)+1];
-  strcpy (this->objFileName, name);
-  this->readFromObjFile ();
+  // splitting the 
+  char* split = NULL;
+
+  if (!(split = strrchr(fileName, '/')))
+    split = strrchr(fileName, '\\'); // windows Case
+  if (split)
+    {
+      int len = split - fileName+1;
+      this->objPath = new char[len +2];
+      strncpy(this->objPath, fileName, len);
+      this->objPath[len] = '\0';
+      PRINTF(1)("Resolved file %s to Path %s.\n", fileName, this->objPath);
+    }
+  this->readFromObjFile (fileName);
   return true;
 }
@@ -113,16 +85,10 @@
    This function does read the file, parses it for the occurence of things like vertices, faces and so on, and executes the specific tasks
 */
-bool OBJModel::readFromObjFile (void)
-{
-  char* fileName = new char [strlen(objPath)+strlen(objFileName)+1];
-  if (this->objFileName != NULL && !strcmp(this->objFileName, ""))
-    return false;
-  strcpy(fileName, this->objPath);
-  strcat(fileName, this->objFileName);
-
+bool OBJModel::readFromObjFile(const char* fileName)
+{
   FILE* stream;
   if( (stream = fopen (fileName, "r")) == NULL)
     {
-      printf("IniParser could not open %s\n", fileName);
+      printf("Object File Could not be Opened %s\n", fileName);
       return false;
     }
@@ -179,5 +145,4 @@
     }
   fclose (stream);
-  delete []fileName;
   return true;
 }
@@ -194,14 +159,12 @@
 bool OBJModel::readMtlLib (const char* mtlFile)
 {
-  this->mtlFileName = new char [strlen(mtlFile)+1];
-  strcpy(this->mtlFileName, mtlFile);
-  char* fileName = new char [strlen(this->objPath) + strlen(this->mtlFileName)+1];
-  sprintf(fileName, "%s%s", this->objPath, this->mtlFileName);
-  
+  char* fileName = new char [strlen(this->objPath) + strlen(mtlFile)+1];
+  sprintf(fileName, "%s%s", this->objPath, mtlFile);
 
   FILE* stream;
   if( (stream = fopen (fileName, "r")) == NULL)
     {
-      printf("IniParser could not open %s\n", fileName);
+      PRINTF(2)("MaterialLibrary could not be opened %s\n", fileName);
+      delete []fileName;
       return false;
     }
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/objModel.h	(revision 4139)
@@ -15,15 +15,12 @@
   OBJModel(const char* fileName, float scaling = 1.0);
   virtual ~OBJModel();
-  void initializeOBJ(void);
 
  private:
   // Variables
   char* objPath;        //!< The Path where the obj and mtl-file are located.
-  char* objFileName;    //!< The Name of the obj-file.
-  char* mtlFileName;    //!< The Name of the mtl-file (parsed out of the obj-file)
 
   ///// readin /////
   bool importFile (const char* fileName);
-  bool readFromObjFile (void);
+  bool readFromObjFile (const char* fileName);
   bool readMtlLib (const char* matFile);
 };
Index: /orxonox/branches/md2_loader/src/lib/graphics/importer/primitive_model.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/importer/primitive_model.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/importer/primitive_model.cc	(revision 4139)
@@ -71,5 +71,4 @@
 void PrimitiveModel::sphereModel(float size, unsigned int detail)
 {
-  int vertexCount = 0;
   if (detail <= 0) 
     detail = 1;
@@ -89,9 +88,10 @@
 			  size * sin(vi) * cos(vj));
 	  this->addVertexTexture(i / (df *2.0), (j-1.0)/(df)+.5);
-	  vertexCount++;
 	}
     }
   this->addVertex(0, -size, 0);
+  this->addVertexTexture(0,0);
   this->addVertex(0, size, 0);
+  this->addVertexTexture(0 ,1);
 
   // defining the binding Faces.
@@ -102,26 +102,26 @@
 	{
 	  
-	  v1 = i*detail + j;
-	  v4 = i*detail + (j+1);
+	  v1 = i*detail + j-1;
+	  v4 = i*detail + j;
 	  
 	  if (i == detail*2 -1)
 	    {
-	      v2 = j;
-	      v3 = j+1;
+	      v2 = j-1;
+	      v3 = j;
 	    }
 	  else
 	    {
-	      v2 = (i+1)*detail + j;
-	      v3 = (i+1)*detail + (j+1);
-	    }
-	  
+	      v2 = (i+1)*detail + j-1;
+	      v3 = (i+1)*detail + j;
+	    }
+
 	  if (j == 0)
 	    {
-	      v1 = vertexCount+1;
+	      v1 = this->getVertexCount()-2;
 	      this->addFace(3, VERTEX_TEXCOORD, v1, v1, v3, v3, v4, v4);
 	    }
 	  else if (j == detail)
 	    {
-	      v3 = vertexCount+2;
+	      v3 = this->getVertexCount()-1;
 	      this->addFace(3, VERTEX_TEXCOORD, v1, v1, v2, v2, v3, v3);
 	    }
@@ -157,17 +157,17 @@
     {
       int p1, p2, p3, p4;
-      p1 = 2*i+1;
-      p2 = 2*i+2;
-      p3 = 2*i+4;
-      p4 = 2*i+3;
+      p1 = 2*i;
+      p2 = 2*i+1;
+      p3 = 2*i+3;
+      p4 = 2*i+2;
       // something is wrong here
       this->addFace(4, VERTEX_ONLY, p1, p2, p3, p4);
-      this->addFace(3, VERTEX_ONLY, p4, p1, 2*detail+1);
-      this->addFace(3, VERTEX_ONLY, p2, p3, 2*detail+2);
+      this->addFace(3, VERTEX_ONLY, p4, p1, 2*detail);
+      this->addFace(3, VERTEX_ONLY, p2, p3, 2*detail+1);
     }
   // caps
-  this->addFace(4, VERTEX_ONLY, 2*detail-1, 2*detail, 2, 1);
-  this->addFace(3, VERTEX_ONLY, 1, 2*detail-1, 2*detail+1);
-  this->addFace(3, VERTEX_ONLY, 2*detail, 2, 2*detail+2);
+  this->addFace(4, VERTEX_ONLY, 2*detail-2, 2*detail-1, 1, 0);
+  this->addFace(3, VERTEX_ONLY, 0, 2*detail-2, 2*detail);
+  this->addFace(3, VERTEX_ONLY, 2*detail-1, 1, 2*detail+1);
 }
 
@@ -198,11 +198,11 @@
     {
       unsigned int v1, v2;
-      v1 = i+3;
+      v1 = i+2;
       if (i == detail -1)
-	v2 = 3;
+	v2 = 2;
       else
-	v2 = i+4;
-      this->addFace(3, VERTEX_ONLY, 1, v1, v2);
-      this->addFace(3, VERTEX_ONLY, 2, v1, v2); 
+	v2 = i+3;
+      this->addFace(3, VERTEX_ONLY, 0, v1, v2);
+      this->addFace(3, VERTEX_ONLY, 1, v1, v2); 
     }
 }
@@ -228,5 +228,5 @@
   unsigned int v1, v2, v3, v4;
   for (int i = 0; i < detail-1; i++)
-    for (int j = 1; j < detail; j++)
+    for (int j = 0; j < detail-1; j++)
       {
 	v1 = i*detail + j;
Index: /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.cc	(revision 4139)
@@ -40,4 +40,5 @@
    this->particleType = type;
    this->particles = NULL;
+   this->deadList = NULL;
    this->setConserve(.8);
    this->setLifeSpan(.1);
@@ -57,4 +58,20 @@
   // delete what has to be deleted here
    ParticleEngine::getInstance()->removeSystem(this);
+
+   // deleting all the living Particles
+   while (this->particles)
+     {
+       Particle* tmpDelPart = this->particles;
+       this->particles = this->particles->next;
+       delete tmpDelPart;
+     }
+
+   // deleting all the dead particles
+   while (this->deadList)
+     {
+       Particle* tmpDelPart = this->deadList;
+       this->deadList = this->deadList->next;
+       delete tmpDelPart;
+     }
 }
 
@@ -199,5 +216,6 @@
 	    {
 	      prevPart->next = tickPart->next;
-	      delete tickPart;
+	      tickPart->next = this->deadList;
+	      this->deadList = tickPart;
 	      tickPart = prevPart->next;
 	    }
@@ -206,5 +224,6 @@
 	      prevPart = NULL;
 	      this->particles = tickPart->next;
-	      delete tickPart;
+	      tickPart->next = this->deadList;
+	      this->deadList = tickPart;
 	      tickPart = this->particles;
 	    }
@@ -266,5 +285,11 @@
       if (unlikely(particles == NULL))
 	{
-	  this->particles = new Particle;
+	  if (likely(deadList != NULL))
+	    {
+	      this->particles = this->deadList;
+	      deadList = deadList->next;
+	    }
+	  else
+	    this->particles = new Particle;
 	  this->particles->next = NULL;
 	}
@@ -272,5 +297,12 @@
       else
 	{
-	  Particle* tmpPart = new Particle;
+	  Particle* tmpPart;
+	  if (likely(deadList != NULL))
+	    {
+	      tmpPart = this->deadList;
+	      deadList = deadList->next;
+	    }
+	  else
+	    tmpPart = new Particle;
 	  tmpPart->next = this->particles;
 	  this->particles = tmpPart;
@@ -300,3 +332,11 @@
   PRINT(0)("  ParticleSystem %s\n", this->name);
   PRINT(0)("  ParticleCount: %d, maximumCount: %d :: filled %d%%\n", this->count, this->maxCount, 100*this->count/this->maxCount);
-}
+  if (deadList)
+    {
+      PRINT(0)("  - ParticleDeadList is used: ");
+      int i = 1;
+      Particle* tmpPart = this->deadList;
+      while (tmpPart = tmpPart->next) ++i;
+      PRINT(0)("count: %d\n", i);
+    }
+}
Index: /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/graphics/particles/particle_system.h	(revision 4139)
@@ -92,4 +92,5 @@
   Material* material;        //!< A Material for all the Particles.
   Particle* particles;       //!< A list of particles of this System.
+  Particle* deadList;        //!< A list of dead Particles in the System.
 
   GLuint* glID;              //!< A List of different gl-List-ID's
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/Makefile.am
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/Makefile.am	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/Makefile.am	(revision 4139)
@@ -7,9 +7,7 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/coord
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gaphics
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/font
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui/gui
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/util
@@ -20,4 +18,7 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/glmenu
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/animation
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/common
 
 #AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
@@ -35,5 +36,18 @@
 	    gui_banner.cc \
 	    gui_keys.cc \
-	    gui_update.cc
+	    gui_update.cc \
+		  $(MAINSRCDIR)/lib/graphics/graphics_engine.cc \
+		  $(MAINSRCDIR)/lib/lang/base_object.cc \
+		  $(MAINSRCDIR)/lib/math/vector.cc \
+		  $(MAINSRCDIR)/util/resource_manager.cc \
+		  $(MAINSRCDIR)/lib/graphics/text_engine.cc \
+		  $(MAINSRCDIR)/lib/coord/p_node.cc \
+		  $(MAINSRCDIR)/lib/coord/null_parent.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/array.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/model.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/objModel.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/material.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/texture.cc \
+		  $(MAINSRCDIR)/lib/graphics/importer/primitive_model.cc 
 
 noinst_HEADERS=gui.h \
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui.cc	(revision 4139)
@@ -53,5 +53,6 @@
 {
   Window* orxonoxGUI = NULL;
-
+  executable = NULL;
+  
   initGUI(argc, argv);
 
@@ -94,4 +95,6 @@
     orxonoxGUI->fill(windowBox);
   }
+
+
   // Reading Values from File
   exec->setConfDir(GUI_DEFAULT_CONF_DIR);
@@ -111,11 +114,18 @@
   // case update //
 #ifdef HAVE_CURL
-  if (static_cast<Option*>(Window::mainWindow->findWidgetByName("auto update", 0))->value == 1)
+  if (static_cast<Option*>(Window::mainWindow->findWidgetByName(CONFIG_NAME_AUTO_UPDATE, 0))->value == 1)
     {
       update->checkForUpdates();
     }
 #endif /* HAVE_CURL */
+}
 
+/**
+   \brief starts the OrxonoxGUI
+*/
+void Gui::startGui(void)
+{
   mainloopGUI();
+  
 #ifndef HAVE_GTK2
   GuiExec::startOrxonox(NULL, exec);
@@ -123,4 +133,12 @@
 }
 
+void Gui::printHelp()
+{
+  Window::mainWindow->walkThrough(Widget::printHelp, 1);
+}
+
+/**
+   \brief a bool that knows if orxonox should be started
+*/
 bool Gui::startOrxonox = false;
 
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui.h	(revision 4139)
@@ -26,4 +26,7 @@
   ~Gui(void);
 
+  void startGui(void);
+  void printHelp(void);
+
   static bool startOrxonox;
 };
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_audio.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_audio.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_audio.cc	(revision 4139)
@@ -36,5 +36,5 @@
 
   audioFrame = new Frame("Audio-Options:");
-  audioFrame->setGroupName("audio");
+  audioFrame->setGroupName(CONFIG_SECTION_AUDIO);
   {
     Box* audioBox;            //!< The Box that holds the audio Options.
@@ -45,18 +45,22 @@
       Slider* effectsVolume;    //!< A Slider for effects volume.
       
-      enableSound = new CheckButton("Disable Sound");
+      enableSound = new CheckButton(CONFIG_NAME_DISABLE_AUDIO);
       enableSound->setFlagName ("no-sound", 0);
+      enableSound->setDescription("Disables Sound", "Check this to disable Sound in Orxonox");
+      enableSound->setDefaultValue(0);
       enableSound->saveability();
       audioBox->fill(enableSound);
-      Label* musicVolumeLabel = new Label("Music Volume");
+      Label* musicVolumeLabel = new Label(CONFIG_NAME_MUSIC_VOLUME);
       audioBox->fill(musicVolumeLabel);
       musicVolume = new Slider("Music Volume", 0, 100);
       musicVolume->setFlagName("music-volume", "m", 80);
+      musicVolume->setDescription("Sets the volume of the ingame music");
       musicVolume->saveability();
       audioBox->fill (musicVolume);
-      Label* effectsVolumeLabel = new Label ("Effects Volume");
+      Label* effectsVolumeLabel = new Label (CONFIG_NAME_EFFECTS_VOLUME);
       audioBox->fill (effectsVolumeLabel);
       effectsVolume = new Slider ("Effects Volume", 0, 100);
       effectsVolume->setFlagName ("effects-volume", "e", 80);
+      effectsVolume->setDescription("Sets the volune of the ingame SoundEffects");
       effectsVolume->saveability();
       audioBox->fill (effectsVolume);
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_banner.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_banner.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_banner.cc	(revision 4139)
@@ -76,5 +76,5 @@
 
     //! \todo add the names of all the guys working on orxonox
-    orxIsLabel = new Label(PACKAGE_NAME " is:\nPatrick Boenzli - main Developer\nBenjamin Grauer - right Hand\n....");
+    orxIsLabel = new Label("           " PACKAGE_NAME " is:\n" ORXONOX_STAFF);
     logoBox->fill(orxIsLabel);
     logoEventBox->fill(logoBox);
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_exec.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_exec.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_exec.cc	(revision 4139)
@@ -53,5 +53,5 @@
 
     execBox = new Box('v');
-    execFrame->setGroupName("misc");
+    execFrame->setGroupName(CONFIG_SECTION_MISC);
     {
       Button* start;               //!< The start Button of orxonox.
@@ -65,16 +65,56 @@
 #endif /* HAVE_GTK2 */
       execBox->fill(start);
-      this->saveSettings = new CheckButton("Save Settings");
+      this->saveSettings = new CheckButton(CONFIG_NAME_SAVE_SETTINGS);
       this->saveSettings->value = 1;
       this->saveSettings->saveability();
       execBox->fill(this->saveSettings);
-      verboseMode = new Menu("verbose mode", "nothing", "error", "warning", "info", "lastItem");
+
+#ifdef DEBUG
+      verboseMode = new Menu(CONFIG_NAME_VERBOSE_MODE, "nothing",
+#if DEBUG >=1
+			     "error",
+#endif
+#if DEBUG >=2
+			     "warning",
+#endif
+#if DEBUG >=3
+			     "info",
+#endif
+#if DEBUG >=4
+			     "debug",
+#endif
+#if DEBUG >=5
+			     "heavydebug",
+#endif
+			     "lastItem");
       verboseMode->setFlagName("verbose", "v", 2);
+      verboseMode->setDescription("Sets the Output Mode", "This Enables Outbug messages\n"
+				  "0: nothing will be displayed, but stuff one cannot do without (eg.GUI)\n"
+#if DEBUG >=1
+				  "1: error: outputs all the above and errors"
+#endif
+#if DEBUG >=2
+				  "2: warning: outputs all the above plus warnings"
+#endif
+#if DEBUG >=3
+				  "3: info: outputs all the above plus Information"
+#endif
+#if DEBUG >=4
+				  "4: debug: displays all the above plus debug information"
+#endif
+#if DEBUG >=5
+				  "5: heavydebug: displays all the above plus heavy debug information: WARNING: the game will run very slow with this."
+#endif
+				  );
       verboseMode->saveability();
       execBox->fill(verboseMode);
-      alwaysShow = new CheckButton("Always Show this Menu");
+#endif
+
+      alwaysShow = new CheckButton(CONFIG_NAME_ALWAYS_SHOW_GUI);
       alwaysShow->setFlagName("gui", "g", 0);
+      alwaysShow->setDescription("shows the gui when starting orxonox");
       alwaysShow->saveability();
       execBox->fill(alwaysShow);
+
       quit = new Button("Quit");
 #ifdef HAVE_GTK2
@@ -111,5 +151,5 @@
   this->confDir = ResourceManager::homeDirCheck(confDir);
 
-  PRINTF(3)("Config Directory is: %s.\n", this->confDir);
+  PRINTF(5)("Config Directory is: %s.\n", this->confDir);
   //! \todo F** Windows-support
 #ifndef __WIN32__
@@ -132,5 +172,5 @@
   this->confFile = new char[strlen(this->confDir)+strlen(fileName)+2];
   sprintf(this->confFile, "%s/%s", this->confDir, fileName);
-  PRINTF(3)("ConfigurationFile is %s.\n", this->confFile);
+  PRINTF(5)("ConfigurationFile is %s.\n", this->confFile);
 }
 
@@ -174,7 +214,7 @@
 {
   int counter = 0;
-  while(counter < depth &&((widget->isOption>0
+  while(counter < depth &&((widget->optionType > GUI_NOTHING
 			      &&(static_cast<Option*>(widget)->isSaveable()))
-			     ||(widget->isOption<0
+			     ||(widget->optionType < GUI_NOTHING
 				&& static_cast<Packer*>(widget)->getGroupName())))
     {
@@ -184,5 +224,5 @@
   
   // check if it is a Packer, and if it is, check if it has a name and if there is something in it.
-  if(widget->isOption <0)
+  if(widget->optionType < GUI_NOTHING)
     {
       if(static_cast<Packer*>(widget)->getGroupName())
@@ -197,7 +237,6 @@
 	}
     } 
-  //  if(widget->isOption == 0)
-  //    printf("%s\n",widget->title);
-  if(widget->isOption >= 1)
+
+  if(widget->optionType > GUI_NOTHING)
     if (static_cast<Option*>(widget)->isSaveable())
       {
@@ -277,5 +316,5 @@
     {
       PRINT(5)("Located Option %s.\n", widget->title);
-      if(widget->isOption >= 1)
+      if(widget->optionType > GUI_NOTHING)
 	static_cast<Option*>(widget)->load(info->variableValue);
     }
@@ -302,5 +341,5 @@
     }
 
-  if(widget->isOption < 0)
+  if(widget->optionType < GUI_NOTHING)
     {
       if(static_cast<Packer*>(widget)->getGroupName() &&
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_flags.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_flags.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_flags.cc	(revision 4139)
@@ -38,4 +38,5 @@
   this->flagsBox->fill(flagsLabel);
   this->shortFlags = new CheckButton("shortFlags");
+  this->shortFlags->setDefaultValue(0);
   this->flagsBox->fill(shortFlags);
 
@@ -76,5 +77,5 @@
 {
   FlagInfo* info =(FlagInfo*)flagInfo;
-  if(widget->isOption >= 1)
+  if(widget->optionType > GUI_NOTHING)
     if (static_cast<Option*>(widget)->value != static_cast<Option*>(widget)->defaultValue )
       {
@@ -90,5 +91,5 @@
 	  }
 
-	if(static_cast<Option*>(widget)->isOption == 2)
+	if(static_cast<Option*>(widget)->optionType > GUI_BOOL)
 	  {
 	    info->flagsLabel->appendText("=");
